
const fs = require('fs');
const path = require('path');
const express = require('../../../../../../Projects/node/node_modules/express');
const puppeteer = require('../../../../../../Projects/node/node_modules/puppeteer');

const srv = express();
srv.use(express.static(path.join(__dirname, 'src')));
srv.use(express.static(path.join(__dirname, '../')));
srv.listen(8727, () => console.log(`HTTP is listening`));

async function main() {
    const browser = await puppeteer.launch();
    const imageNames = [];
    fs.readdirSync('../').forEach(file => {
        if (file.match(/@2x\.png$/)) imageNames.push(file);
    });
    let batches = [];
    let batch = [];
    imageNames.forEach(name => {
        batch.push(name);
        if (batch.length >= 4) {
            batches.push(batch);
            batch = [];
        }
    });
    batches.push(batch);
    let i = 0;
    batches.forEach(async(batch) => {
        for (const name of batch) {
            const page = await browser.newPage();
            await page.goto(`http://localhost:8727/image.html?src=${name}`);
            await page.waitForNetworkIdle();
            const size = await page.evaluate(() => {
                const image = document.querySelector('img');
                console.log(image)
                return { width: image.naturalWidth, height: image.naturalHeight };
            });
            await page.setViewport({
                width: Math.floor(size.width/2),
                height: Math.floor(size.height/2)
            });
            const imageName = name.replace('@2x', '');
            await page.screenshot({
                path: `../${imageName}`,
                type: 'png',
                omitBackground: true
            });
            await page.close();
            console.log(`Saved ${name}`);
            i++;
        }
    });
    setInterval(() => {
        console.log(i, 'of', imageNames.length);
        if (i == imageNames.length) {
            browser.close();
            process.exit();
        }
    }, 1000);
}
main();